DCMTK - Bug #1043

DCMTK does not handle uncompressed color images with YBR_FULL_422 color model correctly
2022-11-09 18:52 - Marco Eichelberg

Status: Closed Start date: 2022-11-09
Priority: Normal Due date:

Assignee: Marco Eichelberg % Done: 100%
Category: Library and Apps Estimated time: 4:00 hours
Target version: 3.6.8

Module: dcmdata, decmijpeg, demijpls, decmijp2k Compiler:

Operating System:

Description

DcmPixelData::getUncompressedFrame() fails to correctly process uncompressed color images with YBR_FULL_422 photometric
interpretation, an encoding that is unusual but explicitly permitted in DICOM. Furthermore, the various compression encoders in
DCMTK also fail to handle such images. In both cases, this is caused by DcmElement::getUncompressedFrameSize(), which does
not take into account that in this case, frame size is rows * columns * 2 and not rows * columns * 3.

There are, however, many uncompressed images that claim to be encoded in YBR_FULL_422, whereas the size of the pixel data
element indicates that they are in fact encoded in YBR_FULL. This may happen if a compression decoder fails to modify the
photometric interpretation after decompression. This case also needs to be handled properly by some heuristic, since it seems to be
more common than actual uncompressed YBR_FULL_422.

Bug reported 2022-10-28 by Tamas Nemeth <TNemeth@erad.com>.

History

#1 - 2023-01-16 15:36 - J6rg Riesmeier

- Assignee set to Marco Eichelberg

#2 - 2023-04-17 18:21 - Marco Eichelberg
- % Done changed from 0 to 100
- Estimated time set to 4:00 h

Closed by commit #e516¢39d3 for the public DCMTK and commit #c6c60f7bb for the private modules.

#3 - 2023-04-17 18:22 - Marco Eichelberg

- Status changed from New to Closed
